#!/usr/bin/perl
######################################################################
# Login / Logout for Links SQL  (v1.1)
# Last Updated: 6/15/00 @ 21:30
#
#
# VERSION NOTES:
# 1.0 - Inital release
# 1.1 - changed script so that UserName and Password are ALWAYS
#       stored for a year
#     - changed function so it could be used as a forums entrace page
######################################################################
#If you are running Links SQL on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";

print "Content-type: text/html\n\n";

eval {

  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \

  require "links.cfg";

};

if ($@) {
    print "Error including required files: $@\n";
    print "Make sure these files exist, permissions are set properly, and paths
are set correctly.";
    exit;
}

&AdjustBGColor;
&PageTopHTML;
$scriptname = qq($CGIURL/login.cgi);

&get_cookie;

&ReadParse;

$action = $in{'action'};
$UserName = $in{'UserName'};
$UserName = &UNHTMLIFY($UserName);
$Password = $in{'Password'};

if ($cookie{'UserName'} && !$action) {
    $UserName = $cookie{'UserName'};
    $Password = $cookie{'Password'};
    $action = "return";
    &CheckLoginID;
    exit;
}

if (!$action) {
 $formaction = qq(confirmlogin);
 $title      = qq(Main Forums Login);
 $message    = qq(Once you are logged in to the forums, your username and
                 password will be remembered until you log out of the forums.);
 &LoginFormHTML("$scriptname","$formaction","$title","$message","$hidden");
 exit;
 }

if ($action eq "confirmlogin") {
  &CheckLoginID;
  exit;
}

if ($action eq "logout") {
  &Logout;
  exit;
}

print "Undefined action: $action";
exit;

sub CheckLoginID {

 if (($UserName eq "") || ($Password eq "")) {
   $message = qq(You did not complete all required form fields!<!-- $UserName - $Password -->);
 } else {
  $NameFound = "no";
  $ProfileNumber = &GetUserNumber($UserName);
  if ($ProfileNumber ne "") {
      $NameFound = "yes";
  } else {
      $NameFound = "no";
  }
  if ($NameFound eq "yes") {
      @thisprofile = &OpenProfile("$ProfileNumber.cgi");
      if ($Password eq "$thisprofile[1]") {
          $pwmatch = "true";
      }
  } else {
      $message = qq(We have no one registered with the user name of $UserName.);
  }
  if (($NameFound eq "yes") && ($pwmatch ne "true")) {
      $message = qq(Sorry, but the password you entered was not correct.  Please try again.<!-- $UserName - $Password -->);
  }
  if ($message) {
     if ($action ne "return") {
        &StandardHTML("$message");
        exit;
     } else {
         $formaction = qq(confirmlogin);
         $title      = qq(Main Forums Login);
         &LoginFormHTML("$scriptname","$formaction","$title","$message","");
         exit;
     }
  }
  &ConfirmLoginHTML;
}
}
sub ConfirmLoginHTML {
   $greet = "Thank you";
   if ($action eq "return") { $greet = "Welcome back"; }
   $ForwardURL = "$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true";
   $where = "the main forums page.";
   &ForwardWithCookies("$ForwardURL", "$greet, $UserName.<P>You are now being automatically taken to $where");
}

sub Logout {
   $ForwardURL = "$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true";
   $where = "the main forums page.";
   $UserName = "";
   $Password = "";
   &ForwardWithCookies("$ForwardURL", "Thank you, you have been logged out.<P>You are now being automatically taken to $where");
}

sub LoginFormHTML {

my ($script, $action, $title, $message, $hidden) = @_;

print<<LoginFormHTML;
<HTML>
<HEAD><TITLE>$BBName - $title</TITLE>
$HeaderInsert
</HEAD>
<BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor">
$Header
$PageTopHTML
<center>
<P>
<FONT SIZE="3" FACE="$FontFace" COLOR="$TimeColor""><b>$title</b></FONT>
<P>
<FORM METHOD=POST ACTION="$script">
$BorderTop
<table cellpadding=4 cellspacing=1 border=0 width="$TableWidth2">
<tr $TableColorStrip><td colspan=2>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$TableStripTextColor">
<B>$message
</b></td></tr>
<TR $AltColumnColor1><TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>UserName:</B></font></td><td><INPUT TYPE="TEXT" NAME="UserName" VALUE="$cookie{'UserName'}" SIZE=20 MAXLENGTH=35></td></tr>
<TR $AltColumnColor2><TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Password:</B></font></td><td><INPUT TYPE="PASSWORD" NAME="Password" VALUE="$cookie{'Password'}" SIZE=20 MAXLENGTH=35>
&nbsp&nbsp;&nbsp; <FONT SIZE="1" FACE="$FontFace"><A HREF="$CGIURL/Ultimate.cgi?action=lostpw">Forget your password?</A></font>
</td></tr>
$FPWWording
</table>
$BorderBottom


<INPUT TYPE=HIDDEN NAME=action VALUE="$action">
$hidden

<P>
<FONT SIZE="1" FACE="$FontFace">
If you do not have a UserName or password you can $RegLinkHere to get one.<BR>
Or, to continue on as a Guest, <a href="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">click here</a>.</FONT>
<P>
<FONT SIZE="$TextSize" FACE="$FontFace">
<INPUT TYPE=SUBMIT VALUE="Submit Identification">
<INPUT TYPE=RESET VALUE="Clear Fields">
</FORM>
</center>
</FONT>$Footer
</BODY></html><noembed>
LoginFormHTML

}

sub AdjustBGColor {

#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($AltColumnColor1 ne ""){
$AltColumnColor1 = qq(bgcolor="$AltColumnColor1");
}
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($CategoryStripColor ne ""){
$CategoryStripColor = qq(bgcolor="$CategoryStripColor");
}
if ($TableColorStrip ne ""){
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}
if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}

}

sub PageTopHTML {

   if ($DisplayRegistration eq "NO") {
      $RegLinkHere = "";
   }  else {
      $RegLinkHere = qq(| <A HREF="$CGIURL/Ultimate.cgi?action=agree"><ACRONYM TITLE="Registration is free!">register</ACRONYM></A> );
   }

   if ($AllowSearch eq "FALSE") {
      $SearchOption = "";
   }  else {
   $SearchOption = qq(| <A HREF="$CGIURL/search.cgi?action=intro&default=$number&site=$SiteCoded"><ACRONYM TITLE="Perform a search by keyword, date, or name.">search</ACRONYM></A>);
   }

$PageTopHTML = qq(
<center>
}

sub ForwardWithCookies {
my $URLwc = shift;
my $TEXTwc = shift;

&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
        $ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
}  else {
        $ExtraInfo = qq(domain=$TheDomain;path=/;);
}
print <<CONFIRM;
<HTML><HEAD>
<meta http-equiv="Refresh" content="4; URL=$URLwc">
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
expireDate = new Date;
if (expireDate.getYear() < 1900) {
expireDate.setYear(expireDate.getYear() + 1900 + 1);
} else {
expireDate.setYear(expireDate.getYear()+1);
}
var nameStorage = getCookie("NameStorage");
var CookieName = escape("$UserName");
var CookiePW = escape("$Password");

document.cookie = "UserName=" + CookieName + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";
document.cookie = "Password=" + CookiePW + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";

function getCookie(name){
var cname = name + "=";
var dc = document.cookie;
if (dc.length > 0) {
    begin = dc.indexOf(cname);
         if (begin != -1) {
        begin += cname.length;
                end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}
// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
<BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor">
$Header
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">
<B>$TEXTwc
<br><br></font><FONT SIZE="1" FACE="$FontFace" COLOR="$LinkColor">
<A HREF="$URLwc">Click here if you do not want to wait any longer (or if your browser does not automatically forward you).</A>
</B>
</FONT>
</ul>
$Footer</body></html><noembed>
CONFIRM
}  ## END Forward With Cookies sr


